#include <simplecpp>
#include <iostream>
#include <cstdlib>
#include <ctime>
#include <string>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

using namespace std;

struct Button
{
    Rectangle r;
    Text t;
    Button(int x,int y, string c)
    {
        r=Rectangle(x,y,200,50);
        t=Text(x,y,c);
    }
    Button(int x,int y, int l, int b,  string c)
    {
        r=Rectangle(x,y,l,b);
        t=Text(x,y,c);
    }
    void hide()
    {
        r.hide();
        t.hide();
    }
    void show()
    {
        r.show();
        t.show();
    }
};
struct playername
{
    int len;
    char name[20];
    playername()
    {
        name[0]='\0';
        len=0;
    }
};
struct score
{
    char name[30];
    int s;
    score()
    {
        name[0]='\0';
        s=0;
    }
};

char grid[15][15], gridsolution[15][15];
int mainalign,level;
string words[10];
playername player;

string* easywords(string words[], int a[]);
string* medwords(string words[], int a[]);
string* hardwords(string words[], int a[]);
int* randomarray(int a[10],int x);
int* fixdup(int a[10], int x);
int checkdup(int a[10]);
string* gettenwords(string words[10], int x);
void WordsIntoGrid(char grid[][15],int align, int align2, string word, int x, int y);
int generategrid(int level, char grid[][15], string words[]);
void hashtorandom(char gridsolution[][15]);
void design();
void howtoplay();
void getgrid(int level);
void highscores();
void showrules();
int chooselevel();
void playgame();
void getgrid();


string* easywords(string words[], int a[])//contains database of 50 easy words
{
    string easy[50]={"AFFECT","ADOPT","ASSUME","BARE","CAPITAL","ALTERNATE",
    "AMORAL","SIGHT","COMPOSE","DUAL","EXTENT","PHASE","LITERAL","FLARE","FLAUNT","HEALTH","IMPLY","HOME","INFER","INSTANT",
    "MEAN","NAVAL","PEAK","PETAL","PORE","QUOTE","REGRET","SACK","SCRIMP","TURBID","TORTURE","WAVE","EXPECT","JAZZ","JUMP",
    "ERODE","ACROSS","FACT","SERVE","PURPOSE","OFTEN","AMOUNT",
    "FAMILY","BREAK","RATIONAL","RULE","STRICT","SYSTEM","DISPLAY","GOAL"};
    for(int i=0;i<10;i++)
    {
         words[i]=easy[a[i]];
    }
    return words;
}

string* medwords(string words[], int a[])//contains database of 50 medium words
{
    string medium[50]={"CENSOR","ALLUDE","PRESUME","BRIDAL","CONFIDENT","CONCURRENT","CIVET","DECENT","DISCREET","EMIGRATE",
    "EMINENT","ENVELOPE","LAWYER","FOUNDER","HISTORIC","MARTIAL","INSTANCE","MEDIAN","TRYST","PALLET","PARAMETER","PERSONAL",
    "PREMIERE","PRESIDENT","FICTION","RELUCTANT","SENSUAL","CONSCIOUS","VENAL","ADJOURN","PRICK","EXAMPLE","ANOTHER",
    "UPDATE","DETAILS","PLANNING","DEFINE","MANAGER","INFLUENCE","INVOLVE","IMPORT","SURFACE","PAVILION","RUMOUR",
    "CHAMPION","CULTURE","DINNER","MONEY","STUDENT","YOUNG"};
    for(int i=0;i<10;i++)
    {
         words[i]=medium[a[i]];
    }
    return words;
}

string* hardwords(string words[], int a[])//contains database of 50 hard words
{
    string hard[50]={"COMPLEMENT","ABHORRENT","ALLUSION","ANECDOTE","CONSCIOUS","ECONOMIC","IMMINENT","EPIDEMIC",
    "SYMPATHY","EXERCISE","EXPEDIENT","FOUNDER","INCREDIBLE","INDICT","INSIDIOUS","AVERAGE","PRACTICAL","INVOLUTES",
    "PRINCIPLE","RESPECT","RETIECENT","CATEGORY","LABOUR","EXTEND","COMPENSATE","WORKER","PAYMENT","CURRENT","MEDICAL",
    "FACILITY","AFFILIATE","COMPLAINT","REFUSAL","CONTACTOR","PERMANENT","INSTITUTE","DEMAND","BELIEVE","DEFICIT","MAINTAIN",
    "APPEASE","DEDICATE","EXISTING","MUTUAL","MONETARY","BACKGROUND","POPULATION","OFFENDER","DEFAULT","GARBAGE"};
    for(int i=0;i<10;i++)
    {
         words[i]=hard[a[i]];
    }
    return words;
}

int* randomarray(int a[10],int x)//generates an array of 10 random numbers in the range 0 to x-1
{
    std::srand(time(0));
    for(int i=0;i<10;i++)
    {
        a[i]=rand()%x;
    }
    return a;
}
int* fixdup(int a[10], int x)//fixes any duplicates in the array of 10 random numbers
{
    int s= checkdup(a);
    if(s==-1)
        return a;
    else
    {
        a[s]=rand()%x;
        fixdup(a,x);
    }
}
int checkdup(int a[10])//checks if there are any duplicate entries in the array of 10 random numbers
{
    for(int i=0;i<9;i++)
    {
        for(int j=i+1;j<10;j++)
        {
            if(a[i]==a[j])
            {
                return j;
            }
        }
    }
    return -1;
}
string* gettenwords(string words[10], int x)//generates the ten random words that will be hidden in the grid
{
    int a[10];
    randomarray(a, 50);
    fixdup(a,50);
    switch(x)
    {
        case 1: easywords(words, a);break;
        case 2: medwords(words,a);break;
        case 3: hardwords(words,a);break;
    }
    return words;
}
void WordsIntoGrid(char grid[][15],int align, int align2, string word, int x, int y)//places the word in the grid
{
    int len= word.length();
    std::srand(time(0));
    if(align==0)//either left to right or up to down
    {
        while(x>(15-len))
            x=rand()%15;
    }
    else if(align==1)//either right to left or down to up
    {
        while(x<(len-1))
                x=rand()%15;
    }
    int b=x;
    //align2=0 implies horizontal
    //align2=1 implies vertical
    for(int j=0;j<len;j++)
    {
        if(align2==0)
            grid[y][b]=word.at(j);
        else
            grid[b][y]=word.at(j);
        if(align==0)
            b++;
        else if(align==1)
            b--;
    }
    mainalign=align2;
}
int generategrid(int level, char grid[][15], string words[])//coordinates generation of solution grid
{
    std::srand(time(0));
    int x[10],y[10];
    randomarray(x,15);
    fixdup(x,15);
    randomarray(y,15);
    fixdup(y,15);
    int z=rand()%2;
    if(level==1)
    {
        for(int i=0;i<10;i++)
        {
            WordsIntoGrid(grid, 0, z, words[i], x[i], y[i]);
        }
    }
    else if(level==2)
    {
        for(int i=0;i<10;i++)
        {
            WordsIntoGrid(grid, 1, z, words[i], x[i], y[i]);
        }
    }
    else if(level==3)
    {
        for(int i=0;i<10;i++)
        {
            WordsIntoGrid(grid, rand()%2, z, words[i], x[i], y[i]);
        }
    }
    return 0;
}
void hashtorandom(char gridsolution[][15])//generates problem grid from the solution grid
{
    std::srand(time(0));
    for(int i=0;i<15;i++)
    {
        for(int j=0;j<15;j++)
        {
            if(gridsolution[i][j]=='#')
            {
                grid[i][j]= (char)((rand()%26)+65);
            }
            else
                grid[i][j]=gridsolution[i][j];
        }
    }
}

void displaygrid(char grid[][15])//displays grid on the output window. Used for my convenience.
{
    for(int i=0;i<15;i++)
    {
        for(int j=0;j<15;j++)
            cout<<grid[i][j]<<" ";
        cout<<endl;
    }
}
void design()//aesthetic value, animation in beginning
{
    Text t(250, 75, "Welcome to WordMania!");
    Rectangle design(250, 75, 170, 25);
    Circle c1,c2;
    c1=Circle(40,175,10);
    c2=Circle(460,175,10);
    Line l1(40,165,40,185);
    Line l2(450,175,470,175);
    for(int i=1;i<15;i++)
    {
        design=Rectangle(250,75,170+(5*i),25+(5*i));
        design.setColor(i);
        t.setColor(15-i);
        c1.scale(1.1);
        c2.scale(1.1);
        c1.setColor(15-i);
        c2.setColor(15-i);
        l1.scale(1.1);
        l2.scale(1.1);
        l1.setColor(15-i);
        l2.setColor(15-i);
        l1.rotate(0.8975);
        l2.rotate(-0.8975);
        c1.move(15,0);
        l1.move(15,0);
        c2.move(-15,0);
        l2.move(-15,0);
        design.imprint();
    }
    for(int i=0;i<=3;i++)
    {
        c1.show();
        c2.show();
        l1.show();
        l2.show();
        wait(0.1);
        c1.hide();
        c2.hide();
        l1.hide();
        l2.hide();
    }
    t.imprint();
}
void highscores()//used to retrieve and display highscores from external file
{
    FILE *fpin;
    fpin=fopen("Highscores.txt","rb");
    Text t[13];
    if (fpin== NULL)
    {
        t[0].reset(250, 250, "No Highscores Available");
    }
    else
    {
        char tname[30],display[35];
        int tscore;
        t[0].reset(250,130, "Highscores: ");
        string q;
        for(int i=1;i<13;i++)
        {
            switch(i)
            {
                case 1: t[1].reset(250,150,"Easy: ");break;
                case 5: t[5].reset(250,270,"Medium: ");break;
                case 9: t[9].reset(250,390,"Hard: ");break;
                default:
                {
                    fscanf(fpin, "%30s%d",tname,&tscore);
                    {
                    stringstream convert;
                    convert <<tscore;
                    q=convert.str();
                    }
                    int i,j;
                    for(i=0;i<30;i++)
                    {
                        if(tname[i]=='\0')
                            break;
                    }
                    for(j=0;j<i;j++)
                    {
                        display[j]=tname[j];
                    }
                    display[j++]=' ';
                    for(i=0;;i++,j++)
                    {
                        if(i==q.length())
                            break;
                        display[j]=q.at(i);
                    }
                    t[i].reset(250,150+(30*i),display);
                }
            }
        }
    }
    Button bx(250,550,"Back to Main Menu");
    while(true)
    {
        XEvent e;
        int x=e.xbutton.x;
        int y=e.xbutton.y;
        if(checkEvent(e)&&mouseButtonPressEvent(e))
        {
            if((x>=150)&&(x<=350))
            {
                if((y>=525)&&(y<=575))
                {
                    return;
                }
            }
        }
    }
}

void showrules()//Description of levels is shown to user
{
    Text t(250, 150, "Description of levels:");
    beginFrame();
    Text trules[26];
    string rules[26]=
    {
        "There are three levels in the game.",
        "In each level, 10 words are hidden in a 15x15 grid",
        "The words to be found are provided to the player","",
        "In each level, the arrangement of the hidden words is different.",
        "The alignment of words in each level is unknown initially.","",
        "The four possible alignments are:",
        "A. Left to Right  B. Right to Left  C. Up to Down  D. Down to Up","",
        "Easy Level: ","All words in either alignment A or in alignment C(only one of the two)",
        "Medium Level: "," All words in either alignment B or in alignment D(only one of the two)",
        "Hard Level: ","All words are arranged either horizonally or vertially",
        "i.e. A and B together or C and D together","",
        "The first task is to find the alignment of the words.",
        "Once the first word is found, ","the alignment of the other words is automatically obtained as above.",
        "Good Luck!"
    };
    for(int i=0;i<26;i++)
    {
        trules[i]=Text(250,170+(16*i),rules[i]);
    }
    Button b(250,550,"Back to main menu");
    endFrame();
    while(true)
    {
        XEvent e;
        int x,y;
        if(checkEvent(e)&&mouseButtonPressEvent(e))
        {
            x=e.xbutton.x;
            y=e.xbutton.y;
            if((x>=150)&&(x<=350))
            {
                if((y>=525)&&(y<=575))
                    return;
            }
        }
    }
}
int chooselevel()//Used by user to choose the level
{
    Text t(250, 200, "Choose level:");
    Button b1(250,250,"Easy"),b2(250,300,"Medium"),b3(250,350,"Hard");
    beginFrame();
    endFrame();
    int x,y;
    while(true)
    {
        XEvent e;
        if(checkEvent(e)&&mouseButtonPressEvent(e))
        {
            x=e.xbutton.x;
            y=e.xbutton.y;
            if((x>=150)&&(x<=350))
            {
                if((y>=225)&&(y<=275))
                {
                    level=1; break;
                }
                else if((y>=275)&&(y<=325))
                {
                    level=2; break;
                }

                else if((y>=325)&&(y<=375))
                {
                    level=3; break;
                }
            }
        }
    }
    return level;
}
void howtoplay()//Used to convey instructions to user regarding how to play
{
    Text t(250, 150, "How to Play");
    beginFrame();
    Text trules[22];
    string rules[22]=
    {
        "You are given a maximum of 2 minutes to find the ten hidden words.",
        "Clicking on a letter in the wordsearch","selects it as a part of your solution.",
        "Each correctly selected letter awards you 10 points","",
        "Each wrongly selected letter deducts 3 points from your score",
        "For each letter that was not selected by you, but was a part of the","solution, 2 points are deducted.",
        "For every second taken to solve the wordsearch, 1 point is deducted.","",
        "The time left displayed below the wordsearch is updated every 10 seconds.",
        "During the process of updation, the mouse click may not be responsive. ",
        "Sorry for the inconvenience.","",
        "On clicking the Submit Solution button,",
        "All correctly selected letters become green.","All wrongly selected letters become red",
        "Letters which were part of the solution but not selected",
        "are marked in black.","Your score is displayed on the screen.","","Good Luck!"
    };
    for(int i=0;i<22;i++)
    {
        trules[i]=Text(250,170+(16*i),rules[i]);
    }
    Button b(250,550,"Back to main menu");
    endFrame();
    while(true)
    {
        XEvent e;
        int x,y;
        if(checkEvent(e)&&mouseButtonPressEvent(e))
        {
            x=e.xbutton.x;
            y=e.xbutton.y;
            if((x>=150)&&(x<=350))
            {
                if((y>=525)&&(y<=575))
                    return;
            }
        }
    }
}
void playgame()//most important function, runs the wordsearch
{
    {
        string nameinput="Enter your name: ";
        string temp;
        Text t(200,250,nameinput);
        char ch;
        while(true)
        {
            XEvent e;
            if(checkEvent(e)&&keyPressEvent(e))//if the user types on the keyboard
            {
                ch=charFromEvent(e);
                temp=ch;
                if(ch==13)//enter key pressed
                    break;
                else if(ch==8)//backspace pressed
                {
                    if(nameinput.length()>17)
                    {
                        player.len--;
                        player.name[player.len]='\0';
                        nameinput=nameinput.substr(0,nameinput.length()-1);
                        t.reset(200,250,nameinput);
                    }
                }
                else if(ch!=32)//no space allowed in name, avoid complication in storing the highscores
                {
                    player.name[player.len]=ch;
                    player.len++;
                    player.name[player.len]='\0';
                    t.reset(200,250,nameinput.append(temp));
                }
            }
        }
        wait(0.25);
    }
    int level=chooselevel();
    getgrid(level);
    Text load(250, 550, "Please wait while the wordsearch loads...");
    Text list[10],textgrid[15][15];
    Rectangle* boxes[15][15];
    for(int i=0;i<15;i++)
    {
        for(int j=0;j<15;j++)
        {
            boxes[i][j]=NULL;
        }
    }
    for(int i=0;i<10;i++)//displays list of words
    {
        list[i]=Text(425,(150+(30*i)),words[i]);
    }
    string c;
    for(int i=0;i<15;i++)//displays problem grid
    {
        beginFrame();
        for(int j=0;j<15;j++)
        {
            c=grid[i][j];
            textgrid[i][j]=Text(50+(20*j),150+(20*i),c);
        }
        endFrame();
    }
    load=Text(250, 550, "Lets Play!");
    for (int i=0;i<3;i++)
    {
        load.hide();
        wait(0.25);
        load.show();
        wait(0.25);
    }
    load.hide();
    beginFrame();
    Button b1(150,525,"Back to main menu"), b2(350,525,"Exit"),soln(425,460,120,40,"Submit Solution");
    endFrame();
    time_t start,now;
    time(&start);//reference point for time
    int tleft=120;
    Text timer,timeleft;
    bool flag=true;//flag=false means the game has ended
    timer=Text(190,450,"seconds left!");
    timeleft=Text(120,450,tleft);
    int correct=0, wrong=0, unattempted=0;
    Text t1,t2,t3;
    while(true)
    {
        XEvent e;
        int x,y;
        if((tleft>0)&&flag)
        {
            time(&now);//indicative of current time
            tleft=120-((int)difftime(now,start)); //the function used gets the time elapsed from the reference time
        }
        if(tleft<0)
            tleft=0;
        if((flag)&&(tleft!=0))
        {
            if(tleft==10)
            {
                timer=Text(190,450,"Hurry! Only 10 seconds left!");
                timeleft.hide();
            }
            else if(tleft%10==0)
                timeleft.reset(130,450,tleft);
        }
        if((tleft==0)&&(flag))
        {
            timer=Text(190,450,"Time's up! Click on Submit Solution to continue.");
            timeleft.hide();
            flag=false;
        }
        if(checkEvent(e)&&mouseButtonPressEvent(e))
        {
            x=e.xbutton.x;
            y=e.xbutton.y;
            if(((x>=40)&&(x<340)&&(y>=140)&&(y<440))&&(flag))//Highlighting boxes in grid
            {
                x=(int)((x-40)/20);
                y=(int)((y-140)/20);
                if(boxes[x][y]==NULL)//selecting the letters
                {
                    boxes[x][y]=new Rectangle(50+(20*x),150+(20*y),19,19);
                    if(boxes[x][y]==NULL)
                    {
                        load=Text(250, 550, "Sorry! Memory Allocation Error. Game will quit in 3 seconds.");
                        wait(3);
                        exit(0);
                    }
                }
                else//deselecting the letters in the grid
                {
                    delete boxes[x][y];
                    boxes[x][y]=NULL;
                }
            }
            if((y>=500)&&(y<=550))
            {
                if((x>=50)&&(x<=250))//return to main menu button
                {
                    for(int i=0;i<15;i++)
                    {
                        for(int j=0;j<15;j++)
                        {
                            if(boxes[i][j]!=NULL)
                                delete boxes[i][j];
                        }
                    }
                    return;
                }
                else if((x>=250)&&(x<=450))//exit button
                {
                    load=Text(200, 580, "Thank you for playing!");
                    wait(0.5);
                    for(int i=0;i<100;i++)
                    {
                        load.move(1,0);
                    }
                    wait(0.5);
                    exit(0);
                }
            }
            if((x>=375)&&(x<=475)&&(y>=440)&&(y<=480))//submit solution button
            {
                flag=false;
                timer=Text(190,450,"Time taken: ");
                timeleft.show();
                timeleft=Text(240,450,120-tleft);
                soln.hide();
                load=Text(250, 580, "Please wait while your score is being calculated");
                for (int i=0;i<3;i++)
                {
                    load.hide();
                    wait(0.3);
                    load.show();
                    wait(0.3);
                }
                int points=0;
                for(int i=0;i<15;i++)//comparing with actual solution grid
                {
                    for(int j=0;j<15;j++)
                    {
                            if((boxes[j][i]==NULL)&&(gridsolution[i][j])!='#')//if correct letter was not chosen by user
                            {
                                    points-=2;
                                    boxes[j][i]=new Rectangle(50+(20*j),150+(20*i),19,19);
                                    (*boxes[j][i]).setColor(BLACK);
                                    unattempted++;
                                    if(boxes[j][i]==NULL)
                                    {
                                        load=Text(250, 550, "Sorry! Memory Allocation Error. Game will quit in 3 seconds.");
                                        wait(3);
                                        exit(0);
                                    }
                            }
                            else if(boxes[j][i]!=NULL)
                            {
                                if((gridsolution[i][j])!='#')//if the letter chosen is correct
                                {
                                    points+=10;
                                    (*boxes[j][i]).setColor(10);
                                    correct++;
                                }
                                else//if the letter chosen is wrong
                                {
                                    points-=3;
                                    wrong++;
                                    (*boxes[j][i]).setColor(12);
                                }
                            }
                        }
                    }
         {//this block is for retriving records and updating them if necessary from the external highscores file
             //this code segment is glitchy and is not entirely functional as needed.
                        FILE *fpin, *fpout;
                        fpout=fopen("Highscores.txt","wb");
                        fpin=fopen("Highscores.txt","rb");
                        if ((fpin== NULL)||(fpout==NULL))
                        {
                            load=Text(250, 550, "Sorry! Memory Allocation Error. Game will quit in 3 seconds.");
                            wait(3);
                            exit(0);
                        }
                        int count=0;
                        char tname[30];
                        int tscore;
                        struct score
                        {
                            char name[30];
                            int s;
                            score()
                            {
                                name[0]='\0';
                                s=0;
                            }
                        };
                        score precord,tmp;
                        for(int i=0;i<player.len;i++)
                        {
                            precord.name[i]=player.name[i];
                        }
                        precord.s=points;
                        int recsize=sizeof(score);
                        long pos,pos2;
                        //the records are stored in the external file as follows
                        //there are 9 records in all
                        //first three represent the top three in easy level
                        //the next three, for medium level
                        //the next three, for hard level
                        while(!feof(fpin))
                        {
                            count++;
                            pos=ftell(fpin);
                            fscanf(fpin, "%30s%d",tname,&tscore);
                            if((count==((level*3)-2))&&(points>=tscore))//if score is greater than the first place score for that level
                            {
                                tmp.s=tscore;
                                for(int i=0;i<player.len;i++)
                                {
                                    tmp.name[i]=tname[i];
                                }
                                pos2=ftell(fpin);
                                fscanf(fpin, "%30s%d",tname,&tscore);
                                precord.s=tscore;
                                for(int i=0;i<player.len;i++)
                                {
                                    precord.name[i]=tname[i];
                                }
                                fseek(fpout, pos2, SEEK_SET);
                                fwrite(&tmp, recsize, 1, fpout);
                                fwrite(&precord, recsize, 1, fpout);
                                precord.s=points;
                                for(int i=0;i<player.len;i++)
                                {
                                    precord.name[i]=player.name[i];
                                }
                                fseek(fpout, pos, SEEK_SET);
                                fwrite(&precord, recsize, 1, fpout);
                            }
                            else if((count==((level*3)-1))&&(points>=tscore))//if score is greater than the second place score for that level
                            {
                                precord.s=tscore;
                                for(int i=0;i<player.len;i++)
                                {
                                    precord.name[i]=tname[i];
                                }
                                fscanf(fpin, "%30s%d",tname,&tscore);
                                fwrite(&precord, recsize, 1, fpout);
                                precord.s=points;
                                for(int i=0;i<player.len;i++)
                                {
                                    precord.name[i]=player.name[i];
                                }
                                fseek(fpout, pos, SEEK_SET);
                                fwrite(&precord, recsize, 1, fpout);
                            }
                            else if((count==(level*3))&&(points>=tscore))//if score is greater than the third place score
                            {
                                fseek(fpout, pos, SEEK_SET);
                                fwrite(&precord, recsize, 1, fpout);
                            }
                        }
                    }           string d;
                    points=points+tleft-120;
                    //each of the three successive blocks uses stringstream to parse integer to string
                    {
                        stringstream convert;
                        convert <<points;
                        d="You have scored "+(convert.str())+ " points";
                        load=Text(250,580,d);
                        load.show();
                    }
                        {
                            stringstream convert;
                            convert <<correct;
                            d="Correct letters chosen: "+(convert.str());
                            t1=Text(90,470,d);
                            t1.show();
                        }
                        {
                            stringstream convert;
                            convert <<wrong;
                            d="Wrong letters chosen: "+(convert.str());
                            t2=Text(300,470,d);
                            t2.show();
                        }
                        {
                            stringstream convert;
                            convert <<unattempted;
                            d="Number of correct letters not chosen: "+(convert.str());
                            t3=Text(190,490,d);
                            t3.show();
                        }
                }
                }
            }
        }


void getgrid(int level)//generates grid
{
    gettenwords(words,level);
    for(int i=0;i<15;i++)
    {
        for(int j=0;j<15;j++)
            gridsolution[i][j]='#';
    }
    generategrid(level,gridsolution,words);
    hashtorandom(gridsolution);
    //displaygrid(grid);
    cout<<endl;
    //displaygrid(gridsolution);
    /*for(int i=0;i<10;i++)
        cout<<words[i]<<endl;*/
    return;
}
int main()
{
    initCanvas("WordMania", 500, 600);
    design();
    beginFrame();
    Button b1(250,250,"Start Game"),b2(250,300,"Level Description"),b3(250,350,"How to play"),b4(250,400,"View Highscores"),b5(250,450,"Exit Game");
    endFrame();
    int x,y;
    while(true)
    {
        XEvent e;
        if(checkEvent(e)&&mouseButtonPressEvent(e))//checking for mouse click
        {
            x=e.xbutton.x;
            y=e.xbutton.y;
            if((x>=150)&&(x<=350))
            {
                if((y>=225)&&(y<=275))//Start game button
                {
                    b1.hide();
                    b2.hide();
                    b3.hide();
                    b4.hide();
                    b5.hide();
                    playgame();
                    b1.show();
                    b2.show();
                    b3.show();
                    b4.show();
                    b5.show();
                }
                else if((y>=275)&&(y<=325))//Level Description Button
                {
                    b1.hide();
                    b2.hide();
                    b3.hide();
                    b4.hide();
                    b5.hide();
                    showrules();
                    b1.show();
                    b2.show();
                    b3.show();
                    b4.show();
                    b5.show();
                }
                else if((y>=325)&&(y<375))//How to Play Button
                {
                    b1.hide();
                    b2.hide();
                    b3.hide();
                    b4.hide();
                    b5.hide();
                    howtoplay();
                    b1.show();
                    b2.show();
                    b3.show();
                    b4.show();
                    b5.show();
                }
                else if((y>=375)&&(y<=425))//Highscores Button
                {
                    b1.hide();
                    b2.hide();
                    b3.hide();
                    b4.hide();
                    b5.hide();
                    highscores();
                    b1.show();
                    b2.show();
                    b3.show();
                    b4.show();
                    b5.show();
                }
                else if((y>=425)&&(y<=475))//Exit button
                {
                    Text t2(200, 500, "Thank you for playing!");
                    wait(0.5);
                    for(int i=0;i<100;i++)//animation
                    {
                        t2.move(1,0);
                    }
                    wait(0.5);
                    return 0;
                }
            }
        }
    }
}
